//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39E326C400D7.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39E326C400D7.cm

//## begin module%39E326C400D7.cp preserve=no
//## end module%39E326C400D7.cp

//## Module: DataSetBase%39E326C400D7; Package body
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/DataSetBase.cxx

//## begin module%39E326C400D7.additionalIncludes preserve=no
//## end module%39E326C400D7.additionalIncludes

//## begin module%39E326C400D7.includes preserve=yes
#include <sstream>
//## end module%39E326C400D7.includes

// DataFactory
#include <XSModel/DataFactory/DataFactory.h>
// SpectralData
#include <XSModel/Data/SpectralData.h>
// DataSetBase
#include <XSModel/Data/DataSetBase.h>
// XSutility
#include <XSUtil/Utils/XSutility.h>


//## begin module%39E326C400D7.declarations preserve=no
//## end module%39E326C400D7.declarations

//## begin module%39E326C400D7.additionalDeclarations preserve=yes
//## end module%39E326C400D7.additionalDeclarations


// Class DataSetBase::NoSuchSpectrum 

DataSetBase::NoSuchSpectrum::NoSuchSpectrum (const string& diag)
  //## begin DataSetBase::NoSuchSpectrum::NoSuchSpectrum%3A2BD4AA0360.hasinit preserve=yes
  : YellowAlert(diag)
  //## end DataSetBase::NoSuchSpectrum::NoSuchSpectrum%3A2BD4AA0360.hasinit
  //## begin DataSetBase::NoSuchSpectrum::NoSuchSpectrum%3A2BD4AA0360.initialization preserve=yes
  //## end DataSetBase::NoSuchSpectrum::NoSuchSpectrum%3A2BD4AA0360.initialization
{
  //## begin DataSetBase::NoSuchSpectrum::NoSuchSpectrum%3A2BD4AA0360.body preserve=yes
  //## end DataSetBase::NoSuchSpectrum::NoSuchSpectrum%3A2BD4AA0360.body
}


// Class DataSetBase 

DataSetBase::DataSetBase(const DataSetBase &right)
  //## begin DataSetBase::DataSetBase%39E31E6C02B4_copy.hasinit preserve=yes
      : m_dataName(right.m_dataName),
        m_legalStartChan(right.m_legalStartChan),
        m_legalEndChan(right.m_legalEndChan), 
        m_dataGroup(right.m_dataGroup),
        m_index(right.m_index),
        m_origNumSources(right.m_origNumSources),
        m_outputFileName(right.m_outputFileName),
        m_outputBckFileName(right.m_outputBckFileName),
        m_aScaleIsKeyword(right.m_aScaleIsKeyword),
        m_bScaleIsKeyword(right.m_bScaleIsKeyword),
        m_runPath(right.m_runPath),
        m_spectralData(0),  // NOTE: spectra are NOT copied here.
        m_protoType(right.m_protoType), //shallow copy is appropriate here.
        m_multiSpectralData(), 
        m_modelNamesForFake(right.m_modelNamesForFake)
  //## end DataSetBase::DataSetBase%39E31E6C02B4_copy.hasinit
  //## begin DataSetBase::DataSetBase%39E31E6C02B4_copy.initialization preserve=yes
  //## end DataSetBase::DataSetBase%39E31E6C02B4_copy.initialization
{
  //## begin DataSetBase::DataSetBase%39E31E6C02B4_copy.body preserve=yes
  //## end DataSetBase::DataSetBase%39E31E6C02B4_copy.body
}

DataSetBase::DataSetBase (const string& name, size_t index, DataPrototype* proto)
  //## begin DataSetBase::DataSetBase%3A1C3F020036.hasinit preserve=yes
      : m_dataName(name),
        m_legalStartChan(0),
        m_legalEndChan(0), 
        m_dataGroup(1),   
        m_index(0),   
        m_origNumSources(1),
        m_outputFileName(""),
        m_outputBckFileName(""),
        m_aScaleIsKeyword(false),
        m_bScaleIsKeyword(false),
        m_runPath(""),
        m_modelNamesForFake(),
        m_spectralData(0),
        m_protoType(proto),
        m_multiSpectralData()
  //## end DataSetBase::DataSetBase%3A1C3F020036.hasinit
  //## begin DataSetBase::DataSetBase%3A1C3F020036.initialization preserve=yes
  //## end DataSetBase::DataSetBase%3A1C3F020036.initialization
{
  //## begin DataSetBase::DataSetBase%3A1C3F020036.body preserve=yes
  //## end DataSetBase::DataSetBase%3A1C3F020036.body
}


DataSetBase::~DataSetBase()
{
  //## begin DataSetBase::~DataSetBase%39E31E6C02B4_dest.body preserve=yes
  destroy();
  //## end DataSetBase::~DataSetBase%39E31E6C02B4_dest.body
}


DataSetBase & DataSetBase::operator=(const DataSetBase &right)
{
  //## begin DataSetBase::operator=%39E31E6C02B4_assign.body preserve=yes
  
  // call copy constructor and create new owning pointer that's a copy of the RHS's
  // spectral data element(s).
  // copying exceptions are passed through.      
        
  DataSetBase temp(right);
  swap(temp); 
  return *this;  
  //## end DataSetBase::operator=%39E31E6C02B4_assign.body
}



//## Other Operations (implementation)
void DataSetBase::swap (DataSetBase& right) throw ()
{
  //## begin DataSetBase::swap%39E3250901DB.body preserve=yes
  std::swap(m_multiSpectralData,right.m_multiSpectralData);
  std::swap(m_spectralData,right.m_spectralData);
  std::swap(m_dataGroup,right.m_dataGroup);
  std::swap(m_legalStartChan,right.m_legalStartChan);
  std::swap(m_legalEndChan,right.m_legalEndChan);
  std::swap(m_protoType,right.m_protoType);
  std::swap(m_origNumSources,right.m_origNumSources);
  std::swap(m_outputFileName,right.m_outputFileName);
  std::swap(m_outputBckFileName,right.m_outputBckFileName);
  std::swap(m_modelNamesForFake,right.m_modelNamesForFake);
  std::swap(m_aScaleIsKeyword,right.m_aScaleIsKeyword);
  std::swap(m_bScaleIsKeyword,right.m_bScaleIsKeyword);
  std::swap(m_runPath,right.m_runPath);
  //## end DataSetBase::swap%39E3250901DB.body
}

void DataSetBase::destroy () throw ()
{
  //## begin DataSetBase::destroy%3A37926A02D5.body preserve=yes
        
  // cannot throw because delete cannot throw,
  // assuming iterator operations can't throw;    
  // spectralData/multiSpectralData are the only owning pointers in DataSetBase.
  // (the DataPrototype pointer is not an owning pointer).
  // calling delete on SpectralData will invoke its dtor which will call its
  // destroy method. 
        
  delete m_spectralData;
  m_spectralData = 0;
  if (!m_multiSpectralData.empty())
  {
        for (std::map<size_t,SpectralData*>::iterator mi = m_multiSpectralData.begin(); 
              mi != m_multiSpectralData.end(); mi++)
        {
                delete mi->second;             
        }              
        m_multiSpectralData.erase(m_multiSpectralData.begin(),m_multiSpectralData.end());
  }  
  //## end DataSetBase::destroy%3A37926A02D5.body
}

void DataSetBase::closeFiles ()
{
  //## begin DataSetBase::closeFiles%3A393F910022.body preserve=yes
  if (m_spectralData) m_spectralData->closeAncillaryFiles();
  
  if (!m_multiSpectralData.empty())
  {
        for ( std::map<size_t,SpectralData*>::iterator cl = m_multiSpectralData.begin();
                cl !=  m_multiSpectralData.end();    ++cl)
        {
                cl->second->closeAncillaryFiles();  
        }        
  }        
  //## end DataSetBase::closeFiles%3A393F910022.body
}

std::map<size_t,SpectralData*>& DataSetBase::multiSpectralData ()
{
  //## begin DataSetBase::multiSpectralData%3A6DB4A7011A.body preserve=yes
  //## end DataSetBase::multiSpectralData%3A6DB4A7011A.body

  return m_multiSpectralData;
}

SpectralData* DataSetBase::spectralData ()
{
  //## begin DataSetBase::spectralData%3A6DB640002D.body preserve=yes
  //## end DataSetBase::spectralData%3A6DB640002D.body

  return m_spectralData;
}

//## Get and Set Operations for Class Attributes (implementation)

void DataSetBase::dataGroup (size_t value)
{
  //## begin DataSetBase::dataGroup%3AAE55530031.set preserve=yes
  m_dataGroup = value;
  
  // If there are already spectral with responses attached (ie.
  // if this is NOT reached from the first call from
  // the xsData handler), make sure that the response data group
  // values are changed as well.  One place where this situation
  // can occur is due to data group renumbering from the
  // DataUtility::fixSequence function. 
  if (!m_multiSpectralData.empty())
  {
     std::map<size_t,SpectralData*>::iterator it = m_multiSpectralData.begin();
     std::map<size_t,SpectralData*>::iterator itEnd = m_multiSpectralData.end();
     while (it != itEnd)
     {
        SpectralData* sd = it->second;
        sd->resetDetsDataGroupNums(value);
        ++it;
     }
  }
  else if (m_spectralData)
  {
     m_spectralData->resetDetsDataGroupNums(value);
  }
  //## end DataSetBase::dataGroup%3AAE55530031.set
}

//## Get and Set Operations for Associations (implementation)

SpectralData*& DataSetBase::multiSpectralData (size_t index)
{
  //## begin DataSetBase::multiSpectralData%39E36C5700BA.qualget preserve=yes
  // Return an entry that already exists so that it can be manipulated.
  // Does NOT create new entries.
  if (index == 0 || m_multiSpectralData.empty())
  {
        return m_spectralData;
  }
  else
  {
        std::map<size_t,SpectralData*>::iterator seek = m_multiSpectralData.find(index);
        if ( seek != m_multiSpectralData.end() ) return seek->second;
        else
        {
                std::ostringstream msg;
                msg     << "Error: spectrum from row # " << index 
                        << " not found in DataSet "  << dataName();
                throw NoSuchSpectrum(msg.str());
        }  
  }      
  //## end DataSetBase::multiSpectralData%39E36C5700BA.qualget
}

// Additional Declarations
  //## begin DataSetBase%39E31E6C02B4.declarations preserve=yes
  //## end DataSetBase%39E31E6C02B4.declarations

//## begin module%39E326C400D7.epilog preserve=yes
//## end module%39E326C400D7.epilog
